## soci 4.1.2

=== CMakeLists.txt ===
# Note: we need >= v3.23 in order to make use of file sets for header installation
cmake_minimum_required(VERSION 3.23...3.31 FATAL_ERROR)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/find_modules")

include(soci_parse_version)
soci_parse_version(
  ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}"
  OUTPUT_VARIABLE SOCI_VERSION
)

project(SOCI
  VERSION ${SOCI_VERSION}
  DESCRIPTION "C++ database access library"
  HOMEPAGE_URL "https://soci.sourceforge.net/"
  LANGUAGES C CXX
)

include(soci_utils)

if (NOT DEFINED CMAKE_CXX_STANDARD OR CMAKE_CXX_STANDARD LESS 14)
  set(CMAKE_CXX_STANDARD 14)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)

include(CMakeDependentOption)
include(CheckIPOSupported)

check_ipo_supported(RESULT LTO_AVAILABLE)

if (SOCI_STATIC)
  set(SHARED_DEFAULT OFF)
elseif(DEFINED BUILD_SHARED_LIBS)
  set(SHARED_DEFAULT ${BUILD_SHARED_LIBS})
else()
  set(SHARED_DEFAULT ON)
endif()

option(SOCI_SHARED "Enable building SOCI as a shared library" ${SHARED_DEFAULT})
option(SOCI_TESTS "Enable building SOCI test cases" ${PROJECT_IS_TOP_LEVEL})
option(WITH_BOOST "Enable Boost support" ON)
cmake_dependent_option(SOCI_LTO "Enable link time optimizations in release builds" ON "LTO_AVAILABLE" OFF)


# Configure LTO for anything but Debug builds (if enabled in the first place)
set(CMAKE_INTERPROCEDURAL_OPTIMIZATION ${SOCI_LTO})
set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_DEBUG OFF)

if (NOT APPLE)
  # This makes runtime loaders look for library dependencies
  # in the same directory as the library is located in.
  # For details see Craig Scott's CppCon 2019 talk

  # Note: The variable's content is set to $ORIGIN literally,
  # this is NOT a butchered cmake variable expansion
  set(CMAKE_INSTALL_RPATH "$ORIGIN")
endif()

if (NOT DEFINED CMAKE_RUNTIME_OUTPUT_DIRECTORY)
  # Ensure that build artifacts are easy to find. And on Windows this
  # guarantees that the built DLLs end up next to applications
  # linking to them as otherwise they won't be found.
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

  if (NOT PROJECT_IS_TOP_LEVEL)
    # If the embedding project does not define these variables, this can lead to
    # inconsistencies which can cause issues on Windows when e.g. the embedding
    # project has an executable that links to a SOCI DLL which will be put into
    # a different directory which will lead to the exe not finding the DLL.
    message(WARNING "Setting CMAKE_{LIBRARY, ARCHIVE, RUNTIME}_DIRECTORY variables which should have done by the embedding cmake project")
  endif()
endif()

if (SOCI_SHARED)
  set(SOCI_LIB_TYPE "SHARED")
else()
  set(SOCI_LIB_TYPE "STATIC")
endif()

# When using shared libraries, use version-dependent suffix in their names.
if (SOCI_SHARED)
  if (WIN32)
    # Use the full version number as ABI version on Windows and define
    # ABI_SUFFIX which is used to add it to the DLL name manually because this
    # is just a convention and so is not done automatically by CMake.
    set(ABI_VERSION "${PROJECT_VERSION_MAJOR}_${PROJECT_VERSION_MINOR}")
    set(ABI_SUFFIX "_${ABI_VERSION}")
  elseif(UNIX)
    # Use same value as for SOVERSION, which is only the major version (and is
    # used automatically to construct the shared libraries names, so there is
    # no need for ABI_SUFFIX).
    set(ABI_VERSION "${PROJECT_VERSION_MAJOR}")
  endif()
endif()


include(soci_compiler_options)
include(soci_install_dirs)

add_subdirectory(src)

include(soci_compat)


if (SOCI_TESTS)
  include(CTest)
  enable_testing()
  add_subdirectory(tests)
endif()


# Packaging
include(CMakePackageConfigHelpers)
configure_package_config_file("soci-config.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/soci-config.cmake"
  INSTALL_DESTINATION "${SOCI_INSTALL_CMAKEDIR}"
)
write_basic_package_version_file(soci-config-version.cmake
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY SameMajorVersion
)
install(
  FILES
    "${CMAKE_CURRENT_BINARY_DIR}/soci-config.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/soci-config-version.cmake"
    DESTINATION "${SOCI_INSTALL_CMAKEDIR}"
)

=== src/CMakeLists.txt ===
add_library(soci_interface INTERFACE)
add_library(SOCI::soci ALIAS soci_interface)

set(SOCI_GENERATED_INCLUDES_DIR "${CMAKE_BINARY_DIR}/include")
file(MAKE_DIRECTORY "${SOCI_GENERATED_INCLUDES_DIR}/soci")

add_subdirectory(core)
add_subdirectory(backends)


###############################################################################
# platform-dependent settings
###############################################################################

include(CheckTypeSize)
check_type_size(long SOCI_SIZEOF_LONG LANGUAGE CXX)

soci_are_types_same(TYPES "int64_t" "long" OUTPUT_VARIABLE SOCI_INT64_T_IS_LONG)
soci_are_types_same(TYPES "int8_t" "char" OUTPUT_VARIABLE SOCI_INT8_T_IS_CHAR)

include(CheckCXXSourceCompiles)
check_cxx_source_compiles(
  "
      __attribute__ (( visibility(\"default\") )) int f1() { return 0; }
      __attribute__ (( visibility(\"hidden\") ))  int f2() { return 1; }

      int main(int argc, char* argv[]) { f1(); f2(); return 0; }
  "
  SOCI_VISIBILITY_ATTRIBUTE_SUPPORTED
)


# Generate the soci-config.h file

set(CONFIG_LINES "#ifndef SOCI_SOCICONFIG_H_INCLUDED" "#define SOCI_SOCICONFIG_H_INCLUDED" "")

set(CONFIG_VARS
  SOCI_EMPTY
  SOCI_DB2
  SOCI_FIREBIRD
  SOCI_MYSQL
  SOCI_ODBC
  SOCI_ORACLE
  SOCI_POSTGRESQL
  SOCI_SQLITE3
  SOCI_VISIBILITY_ATTRIBUTE_SUPPORTED
  SOCI_SIZEOF_LONG
  SOCI_INT64_T_IS_LONG
  SOCI_INT8_T_IS_CHAR
)
set(CONFIG_MACROS
  SOCI_HAVE_EMPTY
  SOCI_HAVE_DB2
  SOCI_HAVE_FIREBIRD
  SOCI_HAVE_MYSQL
  SOCI_HAVE_ODBC
  SOCI_HAVE_ORACLE
  SOCI_HAVE_POSTGRESQL
  SOCI_HAVE_SQLITE3
  SOCI_HAVE_VISIBILITY_SUPPORT
  SOCI_SIZEOF_LONG
  SOCI_INT64_T_IS_LONG
  SOCI_INT8_T_IS_CHAR
)

list(LENGTH CONFIG_MACROS N_CONFIGS)
math(EXPR LAST_CONFIG_IDX "${N_CONFIGS} - 1")

foreach (I RANGE ${LAST_CONFIG_IDX})
  list(GET CONFIG_VARS ${I} CURRENT_VAR)
  list(GET CONFIG_MACROS ${I} CURRENT_MACRO)

  if (${CURRENT_VAR})
    if ("${${CURRENT_VAR}}" MATCHES "[0-9]+")
      list(APPEND CONFIG_LINES "#define ${CURRENT_MACRO} ${${CURRENT_VAR}}")
    else()
      # Assume this is a boolean flag
      list(APPEND CONFIG_LINES "#define ${CURRENT_MACRO} 1")
    endif()
  else()
    list(APPEND CONFIG_LINES "/* #define ${CURRENT_MACRO} */")
  endif()
  list(APPEND CONFIG_LINES "")
endforeach()

list(APPEND CONFIG_LINES "#endif")

list(JOIN CONFIG_LINES "\n" CONFIG_CONTENT)

string(MD5 CONFIG_CONTENT_HASH "${CONFIG_CONTENT}")
if (EXISTS "${SOCI_GENERATED_INCLUDES_DIR}/soci/soci-config.h")
  file(MD5 "${SOCI_GENERATED_INCLUDES_DIR}/soci/soci-config.h" CONFIG_FILE_HASH)
else()
  set(CONFIG_FILE_HASH 0)
endif()

# Only overwrite the soci-config.h file if the generated content is different from the
# file's content in order to avoid needless rebuilding
if (NOT (CONFIG_CONTENT_HASH STREQUAL CONFIG_FILE_HASH))
  file(WRITE "${SOCI_GENERATED_INCLUDES_DIR}/soci/soci-config.h" "${CONFIG_CONTENT}")
endif()

# Append the generated config header to the public headers of the core target
target_sources(soci_core
  PUBLIC
    FILE_SET headers TYPE HEADERS
    BASE_DIRS "${SOCI_GENERATED_INCLUDES_DIR}"
    FILES
      "${SOCI_GENERATED_INCLUDES_DIR}/soci/soci-config.h"
)

=== tests/CMakeLists.txt ===

add_subdirectory(common)


foreach (CURRENT_BACKEND IN LISTS SOCI_ENABLED_BACKENDS)
  string(TOUPPER "${CURRENT_BACKEND}" CURRENT_BACKEND_UPPER)
  string(TOLOWER "${CURRENT_BACKEND}" CURRENT_BACKEND_LOWER)

  set(SOCI_${CURRENT_BACKEND_UPPER}_SKIP_TESTS OFF CACHE BOOL "Whether to skip tests for backend '${CURRENT_BACKEND}'")

  if (NOT SOCI_${CURRENT_BACKEND_UPPER}_SKIP_TESTS)
    add_subdirectory(${CURRENT_BACKEND_LOWER})
  endif()
endforeach()

=== examples/connect/CMakeLists.txt ===
#
# Copyright (C) 2021 Vadim Zeitlin
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# https://www.boost.org/LICENSE_1_0.txt)
#

# This is a very simple example of using SOCI in a CMake-based project.

cmake_minimum_required(VERSION 3.10...3.31 FATAL_ERROR)

project(SOCIExampleConnect)

# Note: SOCI versions before 4.1 rely on hand-written FindSOCI.cmake files to be
# present in downstream projects as SOCI didn't use to ship a config file.
# This is changed in 4.1 thanks to which the desired database backends can
# be specified as components. Known component names are
# - Empty
# - DB2
# - Firebird
# - MySQL
# - ODBC
# - Oracle
# - PostgreSQL
# - SQLite3
# note that some components may still be undefined if the corresponding library is
# not included in the SOCI version installed on your system.
find_package(SOCI 4.1 COMPONENTS Empty REQUIRED)

add_executable(connect connect.cpp)

# Note that linking to SOCI::soci is enough to inherit
# all of SOCI's dependencies, include directories, etc.
target_link_libraries(connect PRIVATE SOCI::soci)

=== examples/subdir-include/CMakeLists.txt ===
# This is a very simple example of using SOCI in a CMake-based project
# when placing SOCI in a subdirectory lib/soci/ of your project.
# For this example, the SOCI backend called Empty is used.

cmake_minimum_required(VERSION 3.23 FATAL_ERROR)

project(SOCIExampleSubdirectoryInclude)

set(SOCI_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR}/soci)

# All compile options need to be set before the SOCI directory gets included.
# The backend you want to use needs to be enabled here. Available options are
# - SOCI_DB2
# - SOCI_EMPTY
# - SOCI_FIREBIRD
# - SOCI_MYSQL
# - SOCI_ODBC
# - SOCI_ORACLE
# - SOCI_POSTGRESQL
# - SOCI_SQLITE3
# each of these options can be set to "ON" or "OFF" or to
# "AUTO" (the default) in which case the backend is included only
# if all of its dependencies are satisfied. If not, the backend
# is disabled but no error is emitted (which is what would happen
# in this case if the backend was set to "ON").
set(SOCI_EMPTY ON CACHE INTERNAL "" FORCE)

# In order to not run into cross-platform issues, the **top-level** project
# should define these variables to ensure all build artefacts (of a given kind)
# end up in the same place.
if (PROJECT_IS_TOP_LEVEL)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}")
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}")
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}")
endif()

# This line needs to be changed to include the directory you placed SOCI in, e.g.
#  add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/lib/soci ${SOCI_BINARY_DIR})
add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/../.. ${SOCI_BINARY_DIR})

add_executable(subdir_include subdir-include.cpp)

# Link to SOCI (SOCI::soci will resolve all requested dependencies automatically)
target_link_libraries(subdir_include
    PRIVATE
      SOCI::soci
)

=== src/backends/CMakeLists.txt ===
set(SOCI_EXISTING_BACKENDS
  "DB2"
  "Empty"
  "Firebird"
  "MySQL"
  "ODBC"
  "Oracle"
  "PostgreSQL"
  "SQLite3"
  CACHE INTERNAL "" FORCE
)
set(ENABLED_BACKENDS "")

foreach(CURRENT_BACKEND IN LISTS SOCI_EXISTING_BACKENDS)
  string(TOUPPER "${CURRENT_BACKEND}" CURRENT_BACKEND_UPPER)
  string(TOLOWER "${CURRENT_BACKEND}" CURRENT_BACKEND_LOWER)

  set(CURRENT_ENABLED_VAR "SOCI_${CURRENT_BACKEND_UPPER}")
  set(
    CURRENT_DESCRIPTION
    "Whether to include the '${CURRENT_BACKEND}' backend. Can be a boolean value or 'AUTO' to include the backend if its dependencies can be satisfied and disable it otherwise."
  )

  # Remember the original value of the cache variable to be restored below.
  if (DEFINED ${CURRENT_ENABLED_VAR})
    set(ORIGINAL_VALUE "${${CURRENT_ENABLED_VAR}}")
  else()
    set(ORIGINAL_VALUE "AUTO")
  endif()

  # Add option to enable/disable the current backend. Note: if the cache variable already exists
  # (e.g. because it has been specified on the command line), this will NOT overwrite the
  # explicitly specified value
  set(${CURRENT_ENABLED_VAR} "AUTO" CACHE STRING "${CURRENT_DESCRIPTION}")


  # Backwards compatibility with the old cmake setup that used WITH_* variables
  # These are now only defined if the user specified them.
  if (DEFINED WITH_${CURRENT_BACKEND_UPPER})
    message(DEPRECATION "Use of the WITH_${CURRENT_BACKEND_UPPER} option is deprecated - use the new ${CURRENT_ENABLED_VAR} instead")
    if (WITH_${CURRENT_BACKEND_UPPER} AND ${CURRENT_ENABLED_VAR})
      # Overwrite the new-style enable-option unless that was set to disable the current backend
      # (Note that non-empty string - in particular "AUTO" - also convert to a true expression).
      # However, the legacy behavior was to only include the backend, if its dependencies are met,
      # so we set to AUTO rather than ON.
      set(${CURRENT_ENABLED_VAR} "AUTO" CACHE STRING "${CURRENT_DESCRIPTION}" FORCE)
    endif()
    # Delete the legacy variable from cache
    unset(WITH_${CURRENT_BACKEND_UPPER} CACHE)
  endif()


  # Convert the value of the current backend's include flag to uppercase
  string(TOUPPER "${${CURRENT_ENABLED_VAR}}" UPPER_VALUE)
  set(${CURRENT_ENABLED_VAR} "${UPPER_VALUE}" CACHE STRING "${CURRENT_DESCRIPTION}" FORCE)


  # Internal variable indicating whether the current backend's include mode is AUTO
  set(CURRENT_AUTO_VAR "SOCI_${CURRENT_BACKEND_UPPER}_AUTO")
  set(${CURRENT_AUTO_VAR} OFF)


  if (${CURRENT_ENABLED_VAR} STREQUAL "AUTO")
    set(${CURRENT_AUTO_VAR} ON)
  elseif (NOT ${CURRENT_ENABLED_VAR} MATCHES "^(ON|OFF|TRUE|FALSE|YES|NO|[YN01])$")
    message(FATAL_ERROR "Invalid value '${${CURRENT_ENABLED_VAR}}' for option '${CURRENT_ENABLED_VAR}'")
  endif()


  if (${CURRENT_ENABLED_VAR})
    add_subdirectory(${CURRENT_BACKEND_LOWER})

    # Verify that the backend hasn't been disabled (happens if include mode is AUTO and there are
    # unmet dependencies.
    if (${CURRENT_ENABLED_VAR})
      list(APPEND ENABLED_BACKENDS "${CURRENT_BACKEND}")
    endif()
  endif()

  # We may have modified the value of this cache variable above, but we don't
  # want to overwrite the user's value if they specified it on the command
  # line, e.g. if they set it to AUTO, it should remain set to AUTO even if we
  # didn't find the backend dependencies during this run because the user
  # might install them before rerunning CMake again. So restore the original
  # value.
  set(${CURRENT_ENABLED_VAR} "${ORIGINAL_VALUE}" CACHE STRING "${CURRENT_DESCRIPTION}" FORCE)
endforeach()

set(SOCI_ENABLED_BACKENDS "${ENABLED_BACKENDS}" CACHE INTERNAL "" FORCE)
message(STATUS "Enabled SOCI backends are: ${ENABLED_BACKENDS}")

=== src/core/CMakeLists.txt ===
include(GNUInstallDirs)

set(SOCI_LIB_PREFIX "${CMAKE_SHARED_LIBRARY_PREFIX}soci_" CACHE STRING "Specifies prefix for the lib directory")
set(SOCI_LIB_SUFFIX "${CMAKE_SHARED_LIBRARY_SUFFIX}" CACHE STRING "Specifies suffix for the lib directory")
set(SOCI_DEBUG_POSTFIX "${CMAKE_DEBUG_POSTFIX}" CACHE STRING "Specifies suffix for the library file in debug mode")


find_package(Threads REQUIRED)

add_library(soci_core
  ${SOCI_LIB_TYPE}
    "backend-loader.cpp"
    "blob.cpp"
    "common.cpp"
    "connection-parameters.cpp"
    "connection-pool.cpp"
    "error.cpp"
    "into-type.cpp"
    "logger.cpp"
    "once-temp-type.cpp"
    "prepare-temp-type.cpp"
    "procedure.cpp"
    "ref-counted-prepare-info.cpp"
    "ref-counted-statement.cpp"
    "row.cpp"
    "rowid.cpp"
    "session.cpp"
    "soci-simple.cpp"
    "statement.cpp"
    "transaction.cpp"
    "unicode.cpp"
    "use-type.cpp"
    "values.cpp"
)

add_library(SOCI::Core ALIAS soci_core)

set_target_properties(
  soci_core PROPERTIES
  SOVERSION ${PROJECT_VERSION_MAJOR}
  VERSION ${PROJECT_VERSION}
  EXPORT_NAME Core
)

# We have to explicitly list all public header files in order for them to get
# installed properly. This will automatically set the BASE_DIR up as an include
# directory for the target wrapped in a BUILD_INTERFACE generator expression.
# Note that we only add the general, public SOCI headers here. Backend-specific
# headers are added by the respective backend target.
target_sources(soci_core
  PUBLIC
    FILE_SET headers TYPE HEADERS
    BASE_DIRS "${PROJECT_SOURCE_DIR}/include/"
    FILES
      "${PROJECT_SOURCE_DIR}/include/soci/backend-loader.h"
      "${PROJECT_SOURCE_DIR}/include/soci/bind-values.h"
      "${PROJECT_SOURCE_DIR}/include/soci/blob-exchange.h"
      "${PROJECT_SOURCE_DIR}/include/soci/blob.h"
      "${PROJECT_SOURCE_DIR}/include/soci/boost-fusion.h"
      "${PROJECT_SOURCE_DIR}/include/soci/boost-gregorian-date.h"
      "${PROJECT_SOURCE_DIR}/include/soci/boost-optional.h"
      "${PROJECT_SOURCE_DIR}/include/soci/boost-tuple.h"
      "${PROJECT_SOURCE_DIR}/include/soci/callbacks.h"
      "${PROJECT_SOURCE_DIR}/include/soci/column-info.h"
      "${PROJECT_SOURCE_DIR}/include/soci/connection-parameters.h"
      "${PROJECT_SOURCE_DIR}/include/soci/connection-pool.h"
      "${PROJECT_SOURCE_DIR}/include/soci/error.h"
      "${PROJECT_SOURCE_DIR}/include/soci/exchange-traits.h"
      "${PROJECT_SOURCE_DIR}/include/soci/fixed-size-ints.h"
      "${PROJECT_SOURCE_DIR}/include/soci/into-type.h"
      "${PROJECT_SOURCE_DIR}/include/soci/into.h"
      "${PROJECT_SOURCE_DIR}/include/soci/is-detected.h"
      "${PROJECT_SOURCE_DIR}/include/soci/log-context.h"
      "${PROJECT_SOURCE_DIR}/include/soci/logger.h"
      "${PROJECT_SOURCE_DIR}/include/soci/noreturn.h"
      "${PROJECT_SOURCE_DIR}/include/soci/once-temp-type.h"
      "${PROJECT_SOURCE_DIR}/include/soci/prepare-temp-type.h"
      "${PROJECT_SOURCE_DIR}/include/soci/procedure.h"
      "${PROJECT_SOURCE_DIR}/include/soci/query_transformation.h"
      "${PROJECT_SOURCE_DIR}/include/soci/ref-counted-prepare-info.h"
      "${PROJECT_SOURCE_DIR}/include/soci/ref-counted-statement.h"
      "${PROJECT_SOURCE_DIR}/include/soci/row-exchange.h"
      "${PROJECT_SOURCE_DIR}/include/soci/row.h"
      "${PROJECT_SOURCE_DIR}/include/soci/rowid-exchange.h"
      "${PROJECT_SOURCE_DIR}/include/soci/rowid.h"
      "${PROJECT_SOURCE_DIR}/include/soci/rowset.h"
      "${PROJECT_SOURCE_DIR}/include/soci/session.h"
      "${PROJECT_SOURCE_DIR}/include/soci/soci-backend.h"
      "${PROJECT_SOURCE_DIR}/include/soci/soci-platform.h"
      "${PROJECT_SOURCE_DIR}/include/soci/soci-simple.h"
      "${PROJECT_SOURCE_DIR}/include/soci/soci-types.h"
      "${PROJECT_SOURCE_DIR}/include/soci/soci-unicode.h"
      "${PROJECT_SOURCE_DIR}/include/soci/soci.h"
      "${PROJECT_SOURCE_DIR}/include/soci/statement.h"
      "${PROJECT_SOURCE_DIR}/include/soci/std-optional.h"
      "${PROJECT_SOURCE_DIR}/include/soci/transaction.h"
      "${PROJECT_SOURCE_DIR}/include/soci/trivial-blob-backend.h"
      "${PROJECT_SOURCE_DIR}/include/soci/type-conversion-traits.h"
      "${PROJECT_SOURCE_DIR}/include/soci/type-conversion.h"
      "${PROJECT_SOURCE_DIR}/include/soci/type-holder.h"
      "${PROJECT_SOURCE_DIR}/include/soci/type-ptr.h"
      "${PROJECT_SOURCE_DIR}/include/soci/type-wrappers.h"
      "${PROJECT_SOURCE_DIR}/include/soci/use-type.h"
      "${PROJECT_SOURCE_DIR}/include/soci/use.h"
      "${PROJECT_SOURCE_DIR}/include/soci/values-exchange.h"
      "${PROJECT_SOURCE_DIR}/include/soci/values.h"
      "${PROJECT_SOURCE_DIR}/include/soci/version.h"
)

target_include_directories(soci_core
  PUBLIC
    "$<INSTALL_INTERFACE:${SOCI_INSTALL_INCLUDEDIR}>"
  PRIVATE
    "${PROJECT_SOURCE_DIR}/include/soci"
    "${PROJECT_SOURCE_DIR}/include/private"
)

if (SOCI_SHARED)
  target_compile_definitions(soci_core
    PUBLIC
      # Define the macro SOCI_DLL on Windows
      $<IF:$<PLATFORM_ID:Windows>,SOCI_DLL,>
  )
endif()

if (WITH_BOOST)
  # Try and find Boost with the date_time component.
  find_package(Boost COMPONENTS date_time QUIET)

  # Note that we shouldn't check Boost_FOUND here as it will be true even if
  # we found only Boost headers, but not the date_time library.
  if (TARGET Boost::date_time)
    set(SOCI_BOOST_DATE_TIME_MESSAGE " (with date_time component)")
    set(SOCI_DEPENDENCY_BOOST_COMPONENTS "date_time" CACHE INTERNAL "Boost components used by SOCI")

    target_link_libraries(soci_core PUBLIC Boost::date_time)
    target_compile_definitions(soci_core PUBLIC SOCI_HAVE_BOOST_DATE_TIME)
  else()
    # If we couldn't find Boost::date_time, retry searching for Boost headers
    # only and use only them, if found.
    if (WITH_BOOST STREQUAL "REQUIRED")
      find_package(Boost REQUIRED)
    else()
      find_package(Boost)
    endif()
  endif()

  # Here Boost_FOUND is true either if we had found date_time in the first
  # find_package() call or just Boost headers in the second one.
  if (Boost_FOUND)
    message(STATUS "Found Boost: v${Boost_VERSION_STRING} in ${Boost_INCLUDE_DIRS}${SOCI_BOOST_DATE_TIME_MESSAGE}")
    set(SOCI_DEPENDENCY_BOOST TRUE CACHE INTERNAL "Whether SOCI depends on Boost")

    target_link_libraries(soci_core PUBLIC Boost::boost Boost::disable_autolinking)
    target_compile_definitions(soci_core PUBLIC SOCI_HAVE_BOOST)
  endif()
endif()

target_link_libraries(soci_core
  PUBLIC
    $<BUILD_INTERFACE:soci_compiler_interface>
  PRIVATE
    Threads::Threads
    ${CMAKE_DL_LIBS}
)

if (DEFINED ABI_SUFFIX)
  set_target_properties(soci_core
    PROPERTIES
      OUTPUT_NAME "soci_core${ABI_SUFFIX}"
  )
endif()

cmake_path(
  ABSOLUTE_PATH SOCI_INSTALL_LIBDIR
  BASE_DIRECTORY "${CMAKE_INSTALL_PREFIX}"
  OUTPUT_VARIABLE SOCI_INSTALL_FULL_LIBDIR
)

target_compile_definitions(soci_core
  PRIVATE
    DEFAULT_BACKENDS_PATH="${SOCI_INSTALL_FULL_LIBDIR}"
    SOCI_LIB_PREFIX="${SOCI_LIB_PREFIX}"
    SOCI_LIB_SUFFIX="${SOCI_LIB_SUFFIX}"
    SOCI_DEBUG_POSTFIX="${SOCI_DEBUG_POSTFIX}"
)
if (DEFINED ABI_VERSION)
  target_compile_definitions(soci_core
    PRIVATE
      SOCI_ABI_VERSION="${ABI_VERSION}"
  )
endif()


install(
  TARGETS soci_core
  EXPORT SOCICoreTargets
  RUNTIME DESTINATION "${SOCI_INSTALL_BINDIR}"
    COMPONENT soci_runtime
  LIBRARY DESTINATION "${SOCI_INSTALL_LIBDIR}"
    COMPONENT          soci_runtime
    NAMELINK_COMPONENT soci_development
  ARCHIVE DESTINATION "${SOCI_INSTALL_LIBDIR}"
    COMPONENT soci_development
  FILE_SET headers DESTINATION "${SOCI_INSTALL_INCLUDEDIR}"
    COMPONENT soci_development
)
# Generate and install a targets file
install(
  EXPORT SOCICoreTargets
  DESTINATION "${SOCI_INSTALL_CMAKEDIR}"
  FILE SOCICoreTargets.cmake
  NAMESPACE SOCI::
  COMPONENT soci_development
)

=== tests/common/CMakeLists.txt ===

add_library(soci_tests_common
  STATIC
    "test-boost.cpp"
    "test-common.cpp"
    "test-connparams.cpp"
    "test-custom.cpp"
    "test-dynamic.cpp"
    "test-lob.cpp"
    "test-main.cpp"
    "test-manual.cpp"
    "test-rowset.cpp"
    "test-unicode.cpp"
)

# Catch headers are sensitive when it comes to being included in different
# contexts and this can lead to issues with all functionality to actually
# running the tests i.e. the main function.
# Therefore, we have to make sure that the main file is not included in
# a unity build.
set_source_files_properties("test-main.cpp"
  PROPERTIES
    SKIP_UNITY_BUILD_INCLUSION TRUE
)

# Required to work around build issues with C++11 and Clang (see https://github.com/SOCI/soci/issues/984)
target_compile_definitions(soci_tests_common
  PUBLIC
    CATCH_CONFIG_CPP11_NO_SHUFFLE
)

target_link_libraries(soci_tests_common
  PUBLIC
    soci_compiler_interface
    SOCI::Core
)

target_include_directories(soci_tests_common
  PUBLIC
    "${PROJECT_SOURCE_DIR}/include/private"
    "${PROJECT_SOURCE_DIR}/tests"
)

if (SOCI_SHARED)
  # We have a test checking for loading backend dynamically which can only be
  # done when using shared libraries, so define a symbol to guard it.
  target_compile_definitions(soci_tests_common PRIVATE SOCI_DYNAMIC_BACKEND)
endif()

=== tests/db2/CMakeLists.txt ===
add_executable(soci_db2_test
  "test-db2.cpp"
)
target_link_libraries(soci_db2_test PRIVATE soci_tests_common SOCI::DB2)

set(SOCI_DB2_TEST_CONNSTR "DSN=SAMPLE;Uid=db2inst1;Pwd=db2inst1;autocommit=off" CACHE STRING "The connection string to use for DB2 tests")

add_test(
  NAME soci_db2_test
  COMMAND soci_db2_test "${SOCI_DB2_TEST_CONNSTR}" "--invisibles"
)

=== tests/empty/CMakeLists.txt ===
add_executable(soci_empty_test
  "test-empty.cpp"
)
target_link_libraries(soci_empty_test PRIVATE soci_tests_common SOCI::Empty)

set(SOCI_EMPTY_TEST_CONNSTR "dummy" CACHE STRING "The connection string to use for Empty tests")

add_test(
  NAME soci_empty_test
  COMMAND soci_empty_test "${SOCI_EMPTY_TEST_CONNSTR}" "--invisibles"
)

=== tests/firebird/CMakeLists.txt ===
add_executable(soci_firebird_test
  "test-firebird.cpp"
)
target_link_libraries(soci_firebird_test PRIVATE soci_tests_common SOCI::Firebird)

set(SOCI_FIREBIRD_TEST_CONNSTR "service=/tmp/soci_test.fdb user=SYSDBA password=masterkey" CACHE STRING "The connection string to use for Firebird tests")

add_test(
  NAME soci_firebird_test
  COMMAND soci_firebird_test "${SOCI_FIREBIRD_TEST_CONNSTR}" "--invisibles"
)

=== tests/mysql/CMakeLists.txt ===
add_executable(soci_mysql_test
  "test-mysql.cpp"
)
target_link_libraries(soci_mysql_test PRIVATE soci_tests_common SOCI::MySQL)

set(SOCI_MYSQL_TEST_CONNSTR "db=soci_test" CACHE STRING "The connection string to use for MySQL tests")

add_test(
  NAME soci_mysql_test
  COMMAND soci_mysql_test "${SOCI_MYSQL_TEST_CONNSTR}" "--invisibles"
)

=== debian/changelog ===
soci (4.1.2-1) unstable; urgency=medium

  * New upstream version 4.1.2, Closes: 1113525
  * Refresh patches
  * Update Standards Version (no changes)
  * Do not attempt to install .a files, since they are no longer built
  * Add .cmake files to dev package
  * Clean additional files. Closes: 1045590

 -- William Blough <bblough@debian.org>  Sun, 19 Oct 2025 13:10:13 -0400

=== debian/control ===
Source: soci
Section: libs
Priority: optional
Maintainer: William Blough <bblough@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               default-libmysqlclient-dev,
               firebird-dev,
               libboost-date-time-dev,
               libboost-dev,
               libpq-dev,
               libsqlite3-dev,
               unixodbc-dev
Standards-Version: 4.7.2
Homepage: http://soci.sourceforge.net/
Vcs-Browser: https://salsa.debian.org/bblough/soci
Vcs-Git: https://salsa.debian.org/bblough/soci.git

Package: libsoci-core4.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++ Database Access Library
 Database access library for C++ that makes the illusion of
 embedding SQL queries in the regular C++ code, staying entirely
 within Standard C++.
 .
 This package provides the shared library.

Package: libsoci-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsoci-core4.0 (= ${binary:Version}),
         libsoci-firebird4.0 (= ${binary:Version}),
         libsoci-mysql4.0 (= ${binary:Version}),
         libsoci-odbc4.0 (= ${binary:Version}),
         libsoci-postgresql4.0 (= ${binary:Version}),
         libsoci-sqlite3-4.0 (= ${binary:Version}),
         ${misc:Depends}
Description: C++ Database Access Library (devel)
 Database access library for C++ that makes the illusion of
 embedding SQL queries in the regular C++ code, staying entirely
 within Standard C++.
 .
 This package provides the development headers.

Package: libsoci-mysql4.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++ Database Access Library (MySQL backend)
 Database access library for C++ that makes the illusion of
 embedding SQL queries in the regular C++ code, staying entirely
 within Standard C++.
 .
 This package provides the MySQL backend.

Package: libsoci-sqlite3-4.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++ Database Access Library (SQLite3 backend)
 Database access library for C++ that makes the illusion of
 embedding SQL queries in the regular C++ code, staying entirely
 within Standard C++.
 .
 This package provides the SQLite3 backend.

Package: libsoci-postgresql4.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++ Database Access Library (PostgreSQL backend)
 Database access library for C++ that makes the illusion of
 embedding SQL queries in the regular C++ code, staying entirely
 within Standard C++.
 .
 This package provides the PostgreSQL backend.

Package: libsoci-firebird4.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++ Database Access Library (Firebird backend)
 Database access library for C++ that makes the illusion of
 embedding SQL queries in the regular C++ code,  staying entirely
 within Standard C++.
 .
 This package provides the Firebird backend.

Package: libsoci-odbc4.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++ Database Access Library (ODBC backend)
 Database access library for C++ that makes the illusion of
 embedding SQL queries in the regular C++ code,  staying entirely
 within Standard C++.
 .
 This package provides the ODBC backend.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed -Wl,-z,now

%:
	dh $@ --buildsystem=cmake

# debmake generated override targets
# This is example for Cmake (See http://bugs.debian.org/641051 )
override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) -DSOCI_EMPTY:BOOLEAN=OFF \
		-DSOCI_CXX11=1

override_dh_auto_test:
	# Run test, but for now, ignore results. (to be fixed later...)
	-dh_auto_test

override_dh_auto_clean:
	rm -f tests/odbc/test-mysql.dsn
	dh_auto_clean

=== debian/tests/control ===
Tests: build
Depends:
 build-essential,
 libsoci-dev,
 libboost-dev,
 default-libmysqlclient-dev,
 firebird-dev,
 libpq-dev,
 libsqlite3-dev,
 unixodbc-dev

=== debian/watch ===
version=4
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/ \
http://sf.net/soci/soci-(\d\S+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
